/***************************************************************************
 *
 * GETINFO.CMD  - Genderte SOCK.CMD von Tobias.Grimm@gmx.de
 *
 *                Getinfo.cmd dient dazu den Status von ISDNPM 3 abzufragen
 *                und auf den PipeMonitor von Sysbar/2 auszugeben.
 *                Angezeigt werden je nach Zustand von ISDNPM
 *
 *                    ISDNPM : DOWN   - ISDNPM ist nicht gestartet
 *                    ISDNPM : OFF    - keine aktive Verbindung
 *                    XXXX : 0:00:39  - XXXX = Der Name ( x.out) und die Zeit
 *
 *                Getinfo fragt nur den 1. Channel ab
 *
 *                Voraussetzungen: ISDNPM 3
 *                                 Sysbar/2
 *
 *                12.06.2001  - klaus.abresch@t-online.de
 *
 ****************************************************************************/

call RxFuncAdd 'SysSleep','RexxUtil','SysSleep'
call RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
call SysLoadFuncs


/* load socket-lib: */

If RxFuncQuery("SockLoadFuncs") Then
Do
  Call RxFuncAdd "SockLoadFuncs","RXSOCK","SockLoadFuncs"
  Call SockLoadFuncs
End


/* socket variable for the connection: */

Socket = SockSocket("AF_INET", "SOCK_STREAM", "0")

CRLF='0d0a'x

/* */


/* Open Socket Connection: */

    rc = Connect("192.168.1.1",4000);
    if rc < 0 then
    do
        say "Socket Connect Error !!!"
        exit 0
    end

/* */

 i=999

/* uid und pwd wie in X:\ISDNPM30\AUTH.TCP angegeben */

  SAY SendCommandAndWait("cmd=auth uid=Klaus pwd=Klaus"||CRLF)


/* ISDNPM soll permanent abgefragt werden */

do forever

     cbc = 'CMD=STATUSHIGH CHANNEL=1'
     SAY SendCommandAndWait(cbc||CRLF)
     CALL ReportInetStatus '\pipe\sb2_inet' in2 ConTyp ' ISDNPM'
     CALL SysSleep(1)

END

/* */

/* Close Socket Connection: */

    rc= Disconnect()

exit 0

/**************************************************************************/
/* connect the socket                                                     */
/**************************************************************************/
Connect:
parse arg ip, port
  Socket = SockSocket("AF_INET", "SOCK_STREAM", "0")
  Call SockGetHostByAddr ip, "Host.!"
  Host.!family = "AF_INET"
  Host.!port = port
  rc=SockConnect( Socket, "Host.!")
return rc

/**************************************************************************/
/* disconnect the socket                                                  */
/**************************************************************************/
DisConnect:
    Call SockShutDown Socket, 2
    Call SockClose Socket
return 0


/**************************************************************************/
/* send a command to the socket and wait for an answer                    */
/* und falls Daten vorhanden sind werte diese aus                         */
/**************************************************************************/

SendCommandAndWait:

parse arg Command
    rc=SockSend(Socket, COMMAND)
    if rc > 0 then
        rc=SockRecv(Socket, "in", 256)
    if rc <= 0 then in =TIMEOUT

/* Auswerten der Daten */
        cnt = 0

                DO WHILE cnt \= 0
                cnt = CHARS(in)
                END

                in2 = SUBSTR(in,11,1)

                IF in2=3 THEN DO
                        ttPOS=POS('TT=',in)
                        ttr=SUBSTR(in,ttPOS)
                        ttEND=POS(" ",ttr)
                        IF ttEND=0
                        THEN ttr=SUBSTR(ttr,4,)
                        ELSE
                        ttr=SUBSTR(ttr,4,ttEND-4)
                        ConTyp=WORD(in,3)
                        ConTyp=DELSTR(ConTyp,1,6)
                        ConTyp=LEFT(ConTyp,(LENGTH(ConTyp)-1))
                 END

        RETURN in2 ttr ConTyp

        END

        IF in = "TIMEOUT" THEN in2="DOWN"

        RETURN in2



/****************************************************************************/
/*  Internet Status Reporter                                                */
/*  Usage: ReportInetStatus( _pipename_,  _filename_, _sName_, _comment_ )  */
/*  _pipename_ = sb2_inet                                                   */
/*  sendet die Daten an Pipe Monitor                                        */
/*  sFile enthlt den ISDNPM 3 Status 0/1/2/3 oder die Verbindungszeit      */
/****************************************************************************/

ReportInetStatus:

  PARSE ARG sPipeName sFile sName sInfo

Select

  WHEN sFile = 0 THEN DO
        i=990
        sFile='OFF'
        sName=' ISDNPM'
        'echo 'sName ':' sFile ' > 'sPipeName;

  END

  WHEN sFile = 3 THEN DO

        CALL HHMMSS
        sFile=ttr
        sName=' 'ConTyp
        'echo 'sName ':' sFile ' > 'sPipeName;

  END


  WHEN sFile = 1 THEN DO

        sFile='Connecting'
        sName=' ISDNPM'
        'echo 'sName ':' sFile ' > 'sPipeName;

  END

  WHEN sFile = 2 THEN DO

        sFile='Connecting'
        sName=' ISDNPM'
        'echo 'sName ':' sFile ' > 'sPipeName;

  END

  OTHERWISE

  sFile='DOWN'
  sName=' ISDNPM'
  'echo 'sName ':' sFile ' > 'sPipeName;

END

RETURN;



/* Formatierung in HH:MM:SS */

HHMMSS:

ol_sec=ttr

 stunden=FORMAT(TRUNC(ol_sec/3600),2)

ol_sec=ol_sec-stunden*3600

 minuten=RIGHT(TRUNC(ol_sec/60),2,0)

ol_sec=RIGHT(ol_sec-minuten*60,2,0)

 online=stunden':'minuten':'ol_sec

ttr=online

RETURN ttr
