/* OLTIME2.CMD berechnet die Onlinezeiten von ISDNPM 3.0   (Klaus Abresch, Bonn 27.9.2000)

   nderung: Farbige Ausgabe
             einzelner Monat oder einzelner Tag
   
   OLTIME2.CMD in das ISDNPM3 Verzeichniss kopieren
   Programmobjekt
   
   Folgende Variablen mssen angepasst werden

   logdatei=                 Name der Log-Datei wie in ISDN.CFG angegeben  hier: logdatei='tdsl.log'

   log_a bis log_e           Name der Verbindung wie in \USER\XXXX.OUT angegeben hier: log_a='T-DSL'
                                                                                       log_b='T-ISDN'

   log_c bis log_e           weitere Namen fr andere Verbindungen               hier: nicht belegt

   Die Say-Anweisungen am Ende des Scriptes sind jeweils ^^^^^^^^^^^ anzupassen

   SAY "T-Online DSL  ..........................    " ol_log_a "hh:mm:ss"
        ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
   SAY "T-Online ISDN ..........................    " ol_log_b "hh:mm:ss"
        ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
   SAY "Provider C    ..........................    " ol_log_c "hh:mm:ss"
        ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
   SAY "Provider D    ..........................    " ol_log_d "hh:mm:ss"
        ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
   SAY "Provider E    ..........................    " ol_log_e "hh:mm:ss"
        ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

   Der Rest sollte so bernommen werden knnen.


*/




IF RxFuncQuery( "SysLoadFuncs" ) THEN DO
   CALL RxFuncAdd 'SysLoadFuncs','REXXUTIL', 'SysLoadFuncs'
   CALL SysLoadFuncs
   END

/* Initialisierung */

/* Farbe */

'@mode 80,25 >nul'
'@ansi on >NUL'

say '1B'x || '[37;44m'
say '1B'x || '[1m'

'@cls'

rot='1B'x || '[37;41m'
gelb='1B'x || '[33;41m'
weiss='1B'x || '[31;41m'
normal='1B'x || '[37;40m'

/* Ende Farbe */

/* Name der Logdatei wie in ISDN.CFG angegeben */

logdatei='P:\ISDNPM30\logs\tdsl.log'


/* Voreinstellunge fr verschiedene Provider  log_x=Name der Verbindung aus xxxx.out */

log_a='T-DSL'                                   /* T-Online mit DSL */
log_b='T-ISDN'                                  /* T-Online mit ISDN */
log_c='test1'                                   /*  */
log_d='test2'                                   /*  */
log_e='test3'                                   /*  */
lcon=''                                         /* letzter gewhlter Provider */
ol_sec_log_a=0                                  /* T-DSL */
ol_sec_log_b=0                                  /* T-ISDN */
ol_sec_log_c=0                                  /*  */
ol_sec_log_d=0                                  /*  */
ol_sec_log_e=0                                  /*  */
ol_sec_log_rest=0                               /* unbekannt */
ol_sec_alle=0                                   /* alle Verbindungen */



monate = "JAN FEB MAR APR MAY JUN JUL AUG SEP OCT NOV DEC DAY"
monat1 = "Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec day"  /* wie ISDNPM 3.0 die Monate im Log schreibt */
monatfull="Januar Februar Mrz April Mai Juni Juli August September Oktober November Dezember"  /* fr Ausgabe */

mopos=0  /* mopos=0 standardmig kein Monat = Auswertung aktueller Tag */
monat=0
/* Ende Initialisierung */


/* Hauptroutine */

PARSE UPPER ARG  monat day


IF monat \= '' THEN CALL MOCHECK

IF monat='' THEN                     /* keine Eingabe fr Monat, auswerten aktueller Tag */
   DO
        monat=LEFT(date('M'),3)
        day=LEFT(date('E'),2)
        if day < 10 THEN day=" "RIGHT(DAY,1)
        vond=heute
        bisd=day monat
        monat=monat right(day,2)
        mopos=1t

   END

CAll Zeiten

CALL FORMATAUSGABE

CALL AUSGABE

 beep(440,50)
 CALL SysCurState 'OFF'
 JN=SysGetKey(NOECHO)


ABBRUCH:

 EXIT .

/* ENDE Hauptroutine */



/******************************************************************************/
/* ZEITEN: holt die geloggten Zeiten aus *.LOG je noch Vorgabe                */
/*         Ordnet die Zeiten den einzelnen Providern zu                       */
/******************************************************************************/


ZEITEN:


stunden=0
minuten=0
ol_sec=0
ol_sec_alle=0
conn=0

                zeile=LINEIN(logdatei)

                /* Datum der ersten Verbindung  notwendig wenn alles ausgewertet wird*/
                IF mopos=0 THEN DO
                vondate=SUBSTR(zeile,6,3)        /* Monat */
                vondate1=SUBSTR(zeile,9,3)       /* Tag */
                vondate2=SUBSTR(zeile,22,4)      /* Jahr */
                vond=vondate1 vondate" "vondate2
                END

                /* bei Vorgabe von Monat suche den ersten Eintrag fr Monat */
                IF mopos = 1 THEN  DO UNTIL vondate = monat
                vondate=SUBSTR(zeile,6,3)        /* Monat */
                vondate1=SUBSTR(zeile,9,3)       /* Tag */
                vondate2=SUBSTR(zeile,22,4)      /* Jahr */
                vond=vondate1 vondate" "vondate2
                IF LINES(logdatei)=0 THEN LEAVE
                zeile=LINEIN(logdatei)
                 END




        DO UNTIL zeile=''


                ttpos=pos('TT=',zeile)

                IF mopos >= 1 THEN do                 /* Abfrage bestimmter Monat oder Tag */

                monpos=pos(monat,zeile)

                IF monpos=0
                THEN ttpos=0

                END                        /* Ende Abfrage bestimmter Monat oder Tag */

                IF ttpos > 0

                THEN DO

                        conn=FORMAT(conn+1,10)
                        ttr=SUBSTR(zeile,ttpos)
                        ttEND=pos(" ",ttr)
                        IF ttEnd=0
                        THEN otime=SUBSTR(ttr,4,)
                        ELSE
                        otime=SUBSTR(ttr,4,ttEND-4)

                       /* Online-Zeiten den verschiedenen Verbindungen zuordnen log_a bis log_e und "Sonstige" */


                       SELECT
                           WHEN pos(log_a,zeile) > 0 THEN DO
                                ol_sec_log_a=ol_sec_log_a+otime
                                lcon=log_a
                                END
                           WHEN pos(log_b,zeile) > 0 THEN DO
                                ol_sec_log_b=ol_sec_log_b+otime
                                lcon=log_b
                                END
                           WHEN pos(log_c,zeile) > 0 THEN DO
                                ol_sec_log_c=ol_sec_log_c+otime
                                lcon=log_c
                                END
                           WHEN pos(log_d,zeile) > 0 THEN DO
                                ol_sec_log_d=ol_sec_log_d+otime
                                lcon=log_d
                                END
                           WHEN pos(log_e,zeile) > 0 THEN DO
                                ol_sec_log_e=ol_sec_log_e+otime
                                lcon=log_e
                                END
                           OTHERWISE DO
                               ol_sec_log_rest=ol_sec_log_rest+otime
                               lcon="unbekannt"
                               END
                       END /*Select*/

                      /* Summe aller Online-Zeiten */

                      ol_sec_alle=ol_sec_alle+otime

               END /* THEN do */

                     /* Datum der letzten Verbindung  */

                      vondate=SUBSTR(zeile,6,3)
                     vondate1=SUBSTR(zeile,9,3)
                     vondate2=SUBSTR(zeile,22,4)


                     IF mopos = 0 THEN   bisd=vondate1 vondate" "vondate2

                     IF mopos = 1 & vondate = monat THEN  bisd=vondate1 vondate" "vondate2






                     zeile=LINEIN(logdatei)

        END  /* Do Until */

                    /* Zeit der letzten Verbindung */

                    last_ol_sec=otime

 /* fr den eingegebenen Monat oder Monat und Tag sind keine Verbindungen geloggt */

 IF Conn=0 THEN DO
        BEEP(440,50)
         If monat="" THEN DO
          SAY " "
          SAY " Die Datei > " logdatei " < ist nicht vorhanden. "
          SAY ""
          SAY " Name und Pfad berprfen."
         END

        IF mopos > 0 THEN DO
         /*monat3=WORD(monatfull,monat2)*/

         SAY ""
         SAY " Fr den angegebenen Zeitraum sind keine Verbindungen geloggt "
         SAY ""
         SAY " " day " " monat
        END

        SAY ""
        SAY "  Abbruch mit jeder Taste"
        CALL SysCurState 'OFF'
        JN=SysGetKey(NOECHO)
        CALL ABBRUCH
 END


RETURN

/*****************/
/* ENDE ZEITEN   */
/*****************/



/************************************************************************/
/* Formatierung der Sekunden in HH:MM:SS                                */
/************************************************************************/

HHMMSS:

        stunden=TRUNC(ol_sec/3600)

        stunden=FORMAT(stunden,4)

        ol_sec=ol_sec-stunden*3600

        minuten=TRUNC(ol_sec/60)

        minuten=RIGHT(minuten,2,0)

        ol_sec=ol_sec-minuten*60

        ol_sec=RIGHT(ol_sec,2,0)

        online=stunden':'minuten':'ol_sec


RETURN
/**************/
/* END HHMMSS */
/**************/




/****************************************************************************/
/* Ausgabe auf den Bildschirm                                               */
/****************************************************************************/

AUSGABE:


/* zuerst die Bildschirmmaske */

pos=SysCurPos(2,5)
SAY "ͻ"
i=3
Do Until  i=24
pos=SysCurPos(i,5)
SAY "                                                                    "
i=i+1
END
pos=SysCurPos(24,5)
SAY "ͼ"

/* Die nachfolgenden SAY-Anweisungen entsprechend den eigenen Bedrfnissen anpassen */

pos=SysCurPos(1,10)
SAY " Online-Zeit mit ISDNPM 3.0 "  vond  " -" bisd" "
pos=SysCurPos(4,8)
SAY "T-Online DSL  ..........................               hh:mm:ss"   /* anpassen */
pos=SysCurPos(6,8)
SAY "T-Online ISDN ..........................               hh:mm:ss"   /* anpassen */
pos=SysCurPos(8,8)
SAY "Provider C    ..........................               hh:mm:ss"   /* anpassen */
pos=SysCurPos(10,8)
SAY "Provider D    ..........................               hh:mm:ss"   /* anpassen */
pos=SysCurPos(12,8)
SAY "Provider E    ..........................               hh:mm:ss"   /* anpassen */
pos=SysCurPos(14,8)
SAY "sonstige      ..........................               hh:mm:ss"   /* anpassen */
pos=SysCurPos(16,8)
SAY "Anzahl der aufgebauten Verbindungen ....    "
pos=SysCurPos(18,8)
SAY "Summe aller Verbindungszeiten ..........               hh:mm:ss"
pos=SysCurPos(20,8)
SAY "letzte Verbindung mit ..................               hh:mm:ss"
pos=SysCurPos(23,10)
say " Fenster schlieen mit Enter "

/* dann die Daten */

pos=syscurpos(4,1)
say rot
pos=SysCurPos(4,51)
SAY ol_log_a" "
pos=SysCurPos(6,51)
SAY ol_log_b" "
pos=SysCurPos(8,51)
SAY ol_log_c" "
pos=SysCurPos(10,51)
SAY ol_log_d" "
pos=SysCurPos(12,51)
SAY ol_log_e" "
pos=SysCurPos(14,51)
SAY ol_rest" "
say gelb
pos=SysCurPos(16,51)
say conn" "
pos=SysCurPos(18,51)
say olsumme" "
pos=SysCurPos(20,30)
say " "lcon" "
pos=syscurPos(20,51)
say lonline" "
pos=syscurpos(24,79)
RETURN   /* END AUSGABE */


/************************************************************************************/
/* MOCHECK: berprft die ARG 'monat' und 'day' auf Stimmigkeit,                    */
/*          konvertiert MONAT in Monat. Wenn ARG 'day' einen Wert hat erweitern der */
/*          Variablen 'monat' mit 'day'                                             */
/************************************************************************************/

MOCHECK:

IF monat \= 'A' THEN DO    /* wurde als Arg ein Monat bergeben ?*/

      IF LENGTH(monat) = 3
        THEN
        mopos=pos(monat,monate)   /* berprfung Monat richtig angegeben */

        ELSE
        mopos = 0


      IF mopos=0 THEN DO
        BEEP(480,100)
        SAY ""
      IF monat <> h THEN SAY "  Falsche Eingabe" monat
      If monat = h THEN SAY "  Hilfe" 
        SAY ""
        SAY ""
        SAY "  Folgende Eingaben sind mglich"
        SAY ""
        SAY "  - ohne Eingabe wird der aktuelle Tag ausgewertet"
        SAY ""
        SAY "  - a wertet alle geloggten Verbindungen aus"
        SAY ""
        SAY "  - Die Eingabe von Monat wertet diesen Monat aus"
        SAY "    z.B.:  nov wertet den November aus."
        SAY ""
        SAY "  - Die Eingabe von Monat und Tag wertet diesen Tag aus"
        SAY "    z.B.:  nov 14 wertet den 14.November aus"
        SAY ""
        SAY "  Die Monate wie folgt eingeben (Gro/Kleinschreibung beliebg)"
        SAY ""
        SAY "  JAN FEB MAR APR MAY JUN JUL AUG SEP OCT NOV DEC"
        SAY ""
        SAY ""
        SAY ""
        SAY ""
        SAY "  Script abbrechen mit LEERTASTE . Alles auswerten - jede Taste"

        CALL SysCurState 'OFF'
         JN=SysGetKey(NOECHO)
         cls
         IF jn = " "  THEN CALL ABBRUCH
      END

        IF mopos >= 1 THEN DO
                mopos=1
                monat2=WORDPOS(monat,monate)
                monat=WORD(monat1,monat2)

        END

        IF day > 0 THEN DO
                if day < 10 THEN day=" "RIGHT(DAY,1)

                vond=day monat
                bisd=day monat
                monat=monat right(day,2)
                mopos=2
        END
        END

RETURN

/*******************/
/*  Ende MOCHECK   */
/*******************/


/*************************************************************************/
/* FORMATAUSGABE:  bergibt die Zeiten an die einzelnen Providereintrge */
/*                 mit gleichzeitiger Formatierung in HH:MM:SS           */
/*************************************************************************/


FORMATAUSGABE:

 /* Summe aller Verbindungen */
  ol_sec=ol_sec_alle
 Call HHMMSS
 olsumme=online

 /*  letzte Verbindung */
 ol_sec=last_ol_sec
 Call HHMMSS
 lonline=online

 /* Provider A */
 ol_sec=ol_sec_log_a
 Call HHMMSS
 ol_log_a=online

 /* Provider B */
 ol_sec=ol_sec_log_b
 Call HHMMSS
 ol_log_b=online

 /* Provider C */
 ol_sec=ol_sec_log_c
 Call HHMMSS
 ol_log_c=online

 /* Provider D */
 ol_sec=ol_sec_log_d
 Call HHMMSS
 ol_log_d=online

 /* Provider E */
 ol_sec=ol_sec_log_e
 Call HHMMSS
 ol_log_e=online

 /* Sonstige */
 ol_sec=ol_sec_log_rest
 Call HHMMSS
 ol_rest=online

RETURN  /* Ende Formatierung Sekunden in hh:mm:ss */

/**********************/
/* ENDE FORMATAUSGABE */
/**********************/
